MCP Tools Reference: dataform.googleapis.com

Tool: query_repository_directory_contents

Return the contents of a given Dataform repository directory.

This tool is primarily used to list and manage single-file assets directly in the repository.

Don't use this tool on repositories connected to a remote Git host. To verify, use the get_repository tool. If the git_remote_settings field is present, the repository is connected to a remote host and you must use the query_directory_contents tool to list a workspace directory instead.

The name parameter value refers to the repository in the format projects/{project_id}/locations/{location}/repositories/{repository}.

The path parameter value must be relative to the repository root. Don't use directory traversal, such as ... If left empty, the repository root is used.

The following code sample shows how to use curl to call the query_repository_directory_contents MCP tool.

Curl Request
curl --location 'https://dataform.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "query_repository_directory_contents",
    "arguments": {
      // Provide these details according to the MCP tool specification.
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'

Input Schema

QueryRepositoryDirectoryContents request message.

QueryRepositoryDirectoryContentsRequest

JSON representation
{
  "name": string,
  "commitSha": string,
  "path": string,
  "pageSize": integer,
  "pageToken": string
}
Fields
name

string

Required. The repository's name.

commitSha

string

Optional. The Commit SHA for the commit to query from. If unset, the directory will be queried from HEAD.

path

string

Optional. The directory's full path including directory name, relative to root. If left unset, the root is used.

pageSize

integer

Optional. Maximum number of paths to return. The server may return fewer items than requested. If unspecified, the server will pick an appropriate default.

pageToken

string

Optional. Page token received from a previous QueryRepositoryDirectoryContents call. Provide this to retrieve the subsequent page.

When paginating, all other parameters provided to QueryRepositoryDirectoryContents, with the exception of page_size, must match the call that provided the page token.

Output Schema

QueryRepositoryDirectoryContents response message.

QueryRepositoryDirectoryContentsResponse

JSON representation
{
  "directoryEntries": [
    {
      object (DirectoryEntry)
    }
  ],
  "nextPageToken": string
}
Fields
directoryEntries[]

object (DirectoryEntry)

List of entries in the directory.

nextPageToken

string

A token, which can be sent as page_token to retrieve the next page. If this field is omitted, there are no subsequent pages.

DirectoryEntry

JSON representation
{
  "metadata": {
    object (FilesystemEntryMetadata)
  },

  // Union field entry can be only one of the following:
  "file": string,
  "directory": string
  // End of list of possible types for union field entry.
}
Fields
metadata

object (FilesystemEntryMetadata)

Entry with metadata.

Union field entry. The entry's contents. entry can be only one of the following:
file

string

A file in the directory. The path is returned including the full folder structure from the root.

directory

string

A child directory in the directory. The path is returned including the full folder structure from the root.

FilesystemEntryMetadata

JSON representation
{
  "sizeBytes": string,
  "updateTime": string
}
Fields
sizeBytes

string (int64 format)

Output only. Provides the size of the entry in bytes. For directories, this will be 0.

updateTime

string (Timestamp format)

Output only. Represents the time of the last modification of the entry.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

Tool Annotations

Tool annotations are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.

Along with the title string, the following boolean hints are defined as follows:

  • readOnlyHint: If true, the tool doesn't modify its environment. Default: false.
  • destructiveHint: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.
  • idempotentHint: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.
  • openWorldHint: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.

Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌